@echo on
pushd "%~dp0"
if "%~dpnx1"=="" echo no file&&pause&&exit
set path="%~dp0"\..\bin1;"%~dp0"\..\bin;"%~dp0"\..\bin1\iasl-win-20161222;%path%
UEFIFind.exe header count 70074A413940B7D029C21F105E92 "%~dpnx1" >nul
if %errorlevel% neq 0 (set Patch=Patch_D3) else set Patch=Patch
if exist "%~dpnx1.dump" rmdir /s /q "%~dpnx1.dump"
rem copy /y "%~dpnx1" "%~dpnx1.bak" >nul

echo ------------Extract module------------
	uefiextract "%~dpnx1" 6B5C8FE5-70DD-4E17-BFF4-D21C26586EB3 1>nul
	uefiextract "%~dpnx1" C118F50D-391D-45F4-B3D3-11BC931AA56D 1>nul
	uefiextract "%~dpnx1" C38FB0E2-0C43-49C9-B544-9B17AA4DCBA3 1>nul
	uefiextract "%~dpnx1" EA139578-FEA0-4DD2-91B5-6953819EF1E4 1>nul
	uefiextract "%~dpnx1" 3BBB09DA-1E0F-469B-8997-D440F101D6F1 1>nul

set refs="%~dp0\%Patch%\refs.txt"
del "%~dp0"\_extract.log 2>nul
del "%~dp0"\_needmod.txt 2>nul
del "%~dp0"\_compile.log 2>nul

for /f "delims=" %%f in ('echo "%~nx1.dump"') do (
	pushd %%~sf
	set work=%%~sf
)

for /f "delims=" %%i in ('dir /s /b *VOLUM* 2^>nul') do move /y "%%i" . >nul
for /r /d %%i in (*C118F50D*) do (
	pushd %%~si
	for /r %%e in (body.bin) do echo %%~se >%work%\dsdtpath.txt
	popd
)
for /f %%o in (dsdtpath.txt) do set dsdtpath=%%~dpo
for /r %%i in (body.bin) do (	
	if exist %%~si (
		setlocal ENABLEDELAYEDEXPANSION
		for /f %%b in ('xxd -ps -l 4 %%~si') do (
			if %%b == 53534454 (
				set ido=1
			) else (
				if %%b == 44534454 (
					set ido=1
				) else (
					set ido=0
				)
			)
		)
		if !ido!==1 (
			iasl -e !dsdtpath!\body.bin -fe %refs% -d %%~si >>"%~dp0"\_extract.log 2>&1
			if !errorlevel! neq 0 (
				iasl -fe %refs% -d %%~si >>"%~dp0"\_extract.log 2>&1)
			)
		)
		endlocal
	)
)
for /r %%i in (body.dsl) do if exist %%~si grep -lobUaP "CPU7|STS7|PDC7|CAP7" %%~si >>"%~dp0"\_needmod.txt


rem DSDT

pushd "%~dp0"
echo --------------Patching----------------
echo A M I
set dsdtdsl=%dsdtpath%\body.dsl
grep -e \"\\\\_PR.CPU7\"\, %dsdtdsl% >nul
if %errorlevel% == 0 (set n1=8) else (set n1=12)
patch.exe "%dsdtdsl%" < Patch_D3\%n1%.diff
sed -i -f %Patch%\sed.txt %dsdtdsl% 
rem for /f %%a in ('sed -n "s/Name (DEVY, Package (\(0x[0-9A-F]\{2\}\))/\1/p" %dsdtdsl%') do set /a replace=%%a + %n1%
rem for /f "tokens=3" %%a in ('hex2dec.cmd %replace%') do sed -i "s/Name (DEVY, Package (0x[0-9A-F]\{2,8\})/Name (DEVY, Package (%%a)/" %dsdtdsl%
sed -i "s/Name (DEVY, Package (0x[0-9A-F]\{2,8\})/Name (DEVY, Package (0x40)/" %dsdtdsl%
patch.exe "%dsdtdsl%" < %Patch%\"A M I.diff"
iasl.exe -G "%dsdtdsl%"  >>_compile.log 2>&1
rem DSDT end

for /f "delims=" %%i in (_needmod.txt) do (
	setlocal ENABLEDELAYEDEXPANSION
	for /f "delims=" %%s in (%Patch%\filelist.txt) do (
		grep -l "%%s" "%%i" >nul
		if !errorlevel! equ 0 (
			echo --------------Patching----------------&&echo %%s
			sed -i -f %Patch%\sed2.txt %%i 
			rem unix2dos %%i 2>nul
			patch.exe "%%i" < %Patch%\"%%s.diff"
			iasl.exe -G "%%i"  >>_compile.log 2>&1
		)
	)
	endlocal
)
echo ------------Check------------
grep "Compilation" _compile.log
echo if all above has 0 Errors,please choose 1
CHOICE /C 12 /N /M "continue: 1,exit: 2"
if %errorlevel%  equ 1 call ACPIRepack %1 && exit /b
if %errorlevel%  equ 2 (
	if exist "%~dpnx1.dump" rmdir /s /q "%~dpnx1.dump"
	if exist _compile.log del _compile.log
	if exist _extract.log del _extract.log
	if exist _needmod.txt del _needmod.txt
	exit /b 404
)
:exit
